/* macro.c  macro expansion
	11 Feb 2005
	use in som vy1   24 Feb 2005
 */

#include "compile.h"

#define PRIVATE static

// return pointer to n-th ele of e
PRIVATE int pick(int e, int n){
	if( e == NIL) return NIL;
	if( n < 1 ) return NIL;
	if( n == 1 ) return car(e);
	return pick(cdr(e),n-1);
}

/*
 map atom a with n-arg in e2, e2 is the actual arg list
 substitute "get.n" with n-th ele of e2
 */
PRIVATE int mapAtom(int a, int e2){
	int e, e3, c, n;
	c = car(a);
	if( c != LNAME ) return a;
	n = cdr(a);
	e3 = pick(e2,n);	// n-arg of caller
	return e3;
}

// e1 is the body of macro def, e2 is the actual arg list
PRIVATE int subst(int e1, int e2){
	int e, e3;
	if( e1 == NIL) return NIL;
	e = car(e1);
	if( isatom(e) ){
		e3 = mapAtom(e,e2);
		return cons(e3,subst(cdr(e1),e2));
	}else
		return cons( subst(e,e2), subst(cdr(e1),e2));
}

// macro expansion
void domacro(int idx, int el){
	int t, body, e;
	int i, c, n, lv, arity, first;
	t = getType(idx);
	if( t == tyMAC ){
//		printf("simple macro\n");
		body = getPref(idx);
		e = subst(body,el);
		genex(e);
	}else{
//		printf("full macro\n");
		genlist(el);
		e = getRef(idx);
		// update currentf
		first = getLv(currentf);
		setLv(currentf,first+getLv(idx));
		// pass param
		arity = getArg(idx);
		for(i=1; i<=arity; i++)
			outa(icPut,first+(arity-i+1));
		// rename body
		decode(e,&c,&n);
		while( c != icEnd ){
			switch(c){
			case icGet:
			case icPut:
			case icInc:
			case icDec: n += first; break;
			}
			outa(c,n);
			e++;
			decode(e,&c,&n);
		}
	}
}

